; icons.s

	GET	macros.s

next_icon	*	0
iconhandle	*	4
mouse_handler	*	8
menu_creator	*	12
key_handler	*	16
caret_handler	*	20
help_handler	*	24
canvas		*	28
icon_size	*	32

window_handle	*	8
c_mouse_handler	*	28
c_key_handler	*	32
c_menu_creator	*	36
c_caret_handler	*	40
c_help_handler	*	52
flags		*	56
nzmouse_handler	*	128					; nz means when on an icon (used by icon.s)
nzcaret_handler	*	132
nzkey_handler	*	136
nzhelp_handler	*	140
nzmenu_creator	*	144
canvas_window	*	148
icon_list	*	236

f_usenzmouse	*	1<<0					; Set if nz-values are to be used
f_usenzcaret	*	1<<1					; Set if nz-values are to be used
f_usenzkey	*	1<<2					; Set if nz-values are to be used
f_usenzhelp	*	1<<3					; Set if nz-values are to be used
f_usenzmenu	*	1<<4					; Set if nz-values are to be used

	MACRO
$l	CLAIM	$a,$b
$l	ADR	r1,$b
	STR	r1,[r0,#$a]
	MEND

	IMPORT	get_3dstatus

	AREA	|____icon_createtext|, CODE, READONLY
	EXPORT	icon_createtext
icon_createtext

	IMPORT	rmalloc
	IMPORT	rfree

	STMFD	r13!,{r0-r7,lr}
	MOV	r7,r0
	MOV	r0,#icon_size
	BL	rmalloc
	TEQ	r0,#0
	STREQ	r0,[r13]
 [ arm32
	LDMEQFD	r13!,{r0-r7,pc}
 |
	LDMEQFD	r13!,{r0-r7,pc}^
 ]
	STR	r0,[r13]
	MOV	r0,r7
	BL	icon_attach
	LDR	r0,[r13]
	STR	r7,[r0,#canvas]
	MOV	r2,#0
	MOV	r3,#canvas-4
icrtt_clear
	STR	r2,[r0,r3]
	SUBS	r3,r3,#4
	BPL	icrtt_clear
	ADD	r1,r7,#canvas_window
	LDR	r2,[r7,#window_handle]
	STR	r2,[r1]
	LDR	r4,[r13,#12]
	ADD	lr,r1,#24
	MOV	r5,#0
icrtt_count
	LDRB	r6,[r4,r5]
	CMP	r5,#12
	STRLEB	r6,[lr,r5]
	CMP	r6,#32
	ADDGE	r5,r5,#1
	BGE	icrtt_count
	STMFD	r13!,{r0-r3,lr}
	MOV	r0,r4
	IMPORT	main_strwidth
	BL	main_strwidth
	MOV	r4,r0
	LDMFD	r13!,{r0-r3,lr}
	LDR	r2,[r13,#4]
	STR	r2,[r1,#4]
	ADD	r2,r2,r4
	ADD	r2,r2,#16
	STR	r2,[r1,#12]
	LDR	r2,[r13,#8]
	STR	r2,[r1,#8]
	ADD	r2,r2,#52
	STR	r2,[r1,#16]
	CMP	r5,#12
	BGT	icrtt_indirect
	LDR	r0,icrtt_flags
	STR	r0,[r1,#20]
icrtt_make
	SWI	XWimp_CreateIcon
	BVS	icon_genericfailure
	LDR	r1,[r13]
	STR	r0,[r1,#iconhandle]
	LDR	r0,[r7,#icon_list]
	STR	r0,[r1,#next_icon]
	STR	r1,[r7,#icon_list]
 [ arm32
	LDMFD	r13!,{r0-r7,pc}
 |
	LDMFD	r13!,{r0-r7,pc}^
 ]
icrtt_indirect
	LDR	r0,icrtt_flags
	ORR	r0,r0,#256
	STR	r0,[r1,#20]
	LDR	r0,[r13,#12]
	MOV	r2,#-1
	MOV	r3,r6
	ADD	r4,r1,#24
	STMIA	r4,{r0,r2,r3}
	B	icrtt_make

icrtt_flags
	DCD	&17000001

	AREA	|____icon_createoldtext|, CODE, READONLY
	EXPORT	icon_createoldtext
icon_createoldtext

	IMPORT	rmalloc
	IMPORT	rfree

	STMFD	r13!,{r0-r7,lr}
	MOV	r7,r0
	MOV	r0,#icon_size
	BL	rmalloc
	TEQ	r0,#0
	STREQ	r0,[r13]
 [ arm32
	LDMEQFD	r13!,{r0-r7,pc}
 |
	LDMEQFD	r13!,{r0-r7,pc}^
 ]
	STR	r0,[r13]
	MOV	r0,r7
	BL	icon_attach
	LDR	r0,[r13]
	STR	r7,[r0,#canvas]
	MOV	r2,#0
	MOV	r3,#canvas-4
oicrtt_clear
	STR	r2,[r0,r3]
	SUBS	r3,r3,#4
	BPL	oicrtt_clear
	ADD	r1,r7,#canvas_window
	LDR	r2,[r7,#window_handle]
	STR	r2,[r1]
	LDR	r4,[r13,#12]
	ADD	lr,r1,#24
	MOV	r5,#0
oicrtt_count
	LDRB	r6,[r4,r5]
	CMP	r5,#12
	STRLEB	r6,[lr,r5]
	CMP	r6,#32
	ADDGE	r5,r5,#1
	BGE	oicrtt_count
	STMFD	r13!,{r0-r3,lr}
	MOV	r0,lr
	IMPORT	main_strwidth
	BL	main_strwidth
	MOV	r4,r0
	LDMFD	r13!,{r0-r3,lr}
	LDR	r2,[r13,#4]
	STR	r2,[r1,#4]
	ADD	r2,r2,r4
	ADD	r2,r2,#16
	STR	r2,[r1,#12]
	LDR	r2,[r13,#8]
	STR	r2,[r1,#8]
	ADD	r2,r2,#44
	STR	r2,[r1,#16]
	CMP	r5,#12
	BGT	oicrtt_indirect
	LDR	r0,oicrtt_flags
	STR	r0,[r1,#20]
oicrtt_make
	SWI	XWimp_CreateIcon
	BVS	icon_genericfailure
	LDR	r1,[r13]
	STR	r0,[r1,#iconhandle]
	LDR	r0,[r7,#icon_list]
	STR	r0,[r1,#next_icon]
	STR	r1,[r7,#icon_list]
 [ arm32
	LDMFD	r13!,{r0-r7,pc}
 |
	LDMFD	r13!,{r0-r7,pc}^
 ]
oicrtt_indirect
	LDR	r0,oicrtt_flags
	ORR	r0,r0,#256
	STR	r0,[r1,#20]
	LDR	r0,[r13,#12]
	MOV	r2,#-1
	MOV	r3,r6
	ADD	r4,r1,#24
	STMIA	r4,{r0,r2,r3}
	B	oicrtt_make

oicrtt_flags
	DCD	&17000001

	AREA	|____icon_createforgetful|, CODE, READONLY
	EXPORT	icon_createforgetful
icon_createforgetful

	MOV	r12,r13
	STMFD	r13!,{r1-r7,lr}
	MOV	r7,r0
	ADD	r1,r7,#canvas_window
	LDR	r2,[r7,#window_handle]
	STR	r2,[r1]
	LDMIA	r13,{r2-r4}
	ADD	r0,r1,#4
	STMIA	r0!,{r2-r4}
	LDMIA	r12,{r2-r4}
	LDMIA	r4,{r4-r6}
	STMIA	r0!,{r2-r6}					; Store rest of icon to be created
	SWI	XWimp_CreateIcon
	MOVVS	r0,#-1
 [ arm32
	LDMFD	r13!,{r1-r7,pc}
 |
	LDMFD	r13!,{r1-r7,pc}^
 ]

	AREA	|____icon_create|, CODE, READONLY
	EXPORT	icon_create
icon_create

	MOV	r12,r13
	STMFD	r13!,{r0-r8,lr}
	MOV	r8,r12
	MOV	r7,r0
	MOV	r0,#icon_size
	BL	rmalloc
	TEQ	r0,#0
	STREQ	r0,[r13]
 [ arm32
	LDMEQFD	r13!,{r0-r8,pc}
 |
	LDMEQFD	r13!,{r0-r8,pc}^
 ]
	STR	r0,[r13]
	MOV	r0,r7
	BL	icon_attach
	LDR	r0,[r13]
	STR	r7,[r0,#canvas]
	MOV	r2,#0
	MOV	r3,#canvas-4
icrt_clear
	STR	r2,[r0,r3]
	SUBS	r3,r3,#4
	BPL	icrt_clear
	ADD	r1,r7,#canvas_window
	LDR	r2,[r7,#window_handle]
	STR	r2,[r1]
	LDMIB	r13,{r2-r4}
	ADD	r0,r1,#4
	STMIA	r0!,{r2-r4}
	LDMIA	r8,{r2-r4}
	LDMIA	r4,{r4-r6}
	STMIA	r0!,{r2-r6}					; Store rest of icon to be created
	SWI	XWimp_CreateIcon
	BVS	icrt_failed
	LDR	r1,[r13]
	STR	r0,[r1,#iconhandle]
	LDR	r0,[r7,#icon_list]
	STR	r0,[r1,#next_icon]
	STR	r1,[r7,#icon_list]
 [ arm32
	LDMFD	r13!,{r0-r8,pc}
 |
	LDMFD	r13!,{r0-r8,pc}^
 ]
icrt_failed
	LDR	r0,[r13]
	BL	rfree
	MOV	r0,#0
	STR	r0,[r13]
 [ arm32
	LDMFD	r13!,{r0-r8,pc}
 |
	LDMFD	r13!,{r0-r8,pc}^
 ]

	AREA	icon_attach, CODE, READONLY

	CLAIM	nzmouse_handler,icon_mouse
	CLAIM	nzcaret_handler,icon_caret
	CLAIM	nzkey_handler,icon_key
	CLAIM	nzhelp_handler,icon_help
	CLAIM	nzmenu_creator,icon_menu
	LDR	r1,[r0,#flags]
	ORR	r1,r1,#&1f
	STR	r1,[r0,#flags]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

icon_mouse
	STMFD	r13!,{r4,r5,lr}
	MOV	r5,r0
	MOV	r4,r1
	LDR	r1,[r4,#16]
	BL	icon_find
	TEQ	r0,#0
	LDRNE	r3,[r0,#mouse_handler]
	TEQNE	r3,#0
	LDREQ	r3,[r5,#c_mouse_handler]
	MOVEQ	r0,r4
	TEQ	r3,#0
 [ arm32
	LDMEQFD	r13!,{r4,r5,pc}
 |
	LDMEQFD	r13!,{r4,r5,pc}^
 ]
	MOV	r1,r0
	MOV	r2,r4
	MOV	r0,r5
	MOV	lr,pc
	MOV	pc,r3
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

icon_caret
	STMFD	r13!,{r4-r6,lr}
	MOV	r6,r2
	MOV	r5,r0
	MOV	r4,r1
	LDR	r1,[r4,#4]
	BL	icon_find
	TEQ	r0,#0
	MOV	r3,r6
	LDRNE	r6,[r0,#caret_handler]
	TEQNE	r6,#0
	LDREQ	r6,[r5,#c_caret_handler]
	MOVEQ	r0,r4
	MOVEQ	r4,r3
	TEQ	r6,#0
 [ arm32
	LDMEQFD	r13!,{r4-r6,pc}
 |
	LDMEQFD	r13!,{r4-r6,pc}^
 ]
	MOV	r1,r0
	MOV	r2,r4
	MOV	r0,r5
	MOV	lr,pc
	MOV	pc,r6
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]

icon_key
	STMFD	r13!,{r4-r5,lr}
	MOV	r5,r0
	MOV	r4,r1
	LDR	r1,[r4,#4]
	BL	icon_find
	TEQ	r0,#0
	LDRNE	r3,[r0,#key_handler]
	TEQNE	r3,#0
	LDREQ	r3,[r5,#c_key_handler]
	MOVEQ	r0,r4
	TEQ	r3,#0
 [ arm32
	LDMEQFD	r13!,{r4-r5,pc}
 |
	LDMEQFD	r13!,{r4-r5,pc}^
 ]
	MOV	r1,r0
	MOV	r2,r4
	MOV	r0,r5
	MOV	lr,pc
	MOV	pc,r3
 [ arm32
	LDMFD	r13!,{r4-r5,pc}
 |
	LDMFD	r13!,{r4-r5,pc}^
 ]

icon_menu
	STMFD	r13!,{r4-r5,lr}
	MOV	r5,r0
	MOV	r4,r1
	LDR	r1,[r4,#16]
	BL	icon_find
	TEQ	r0,#0
	LDRNE	r3,[r0,#menu_creator]
	TEQNE	r3,#0
	LDREQ	r3,[r5,#c_menu_creator]
	MOVEQ	r0,r4
	TEQ	r3,#0
 [ arm32
	LDMEQFD	r13!,{r4-r5,pc}
 |
	LDMEQFD	r13!,{r4-r5,pc}^
 ]
	MOV	r1,r0
	MOV	r2,r4
	MOV	r0,r5
	MOV	lr,pc
	MOV	pc,r3
 [ arm32
	LDMFD	r13!,{r4-r5,pc}
 |
	LDMFD	r13!,{r4-r5,pc}^
 ]

icon_help
	STMFD	r13!,{r4-r5,lr}
	MOV	r5,r0
	MOV	r4,r1
	LDR	r1,[r4,#36-20]
	BL	icon_find
	TEQ	r0,#0
	LDRNE	r3,[r0,#help_handler]
	TEQNE	r3,#0
	LDREQ	r3,[r5,#c_help_handler]
	MOVEQ	r0,r4
	TEQ	r3,#0
 [ arm32
	LDMEQFD	r13!,{r4-r5,pc}
 |
	LDMEQFD	r13!,{r4-r5,pc}^
 ]
	MOV	r1,r0
	MOV	r2,r4
	MOV	r0,r5
	MOV	lr,pc
	MOV	pc,r3
 [ arm32
	LDMFD	r13!,{r4-r5,pc}
 |
	LDMFD	r13!,{r4-r5,pc}^
 ]

	EXPORT	icon_find

icon_find
; r0 is ^ canvas
; r1 is icon handle
	STMFD	r13!,{r1-r3,lr}
	LDR	r2,[r0,#icon_list]
ifnd_loop
	TEQ	r2,#0
	MOVEQ	r0,#0
 [ arm32
	LDMEQFD	r13!,{r1-r3,pc}
 |
	LDMEQFD	r13!,{r1-r3,pc}^
 ]
	LDR	r3,[r2,#iconhandle]
	TEQ	r3,r1
	MOVEQ	r0,r2
 [ arm32
	LDMEQFD	r13!,{r1-r3,pc}
 |
	LDMEQFD	r13!,{r1-r3,pc}^
 ]
	LDR	r2,[r2,#next_icon]
	B	ifnd_loop

	AREA	|____icon_setbuttontype|, CODE, READONLY
	EXPORT	icon_setbuttontype
icon_setbuttontype

	MOV	r2,r1,LSL#12
	AND	r2,r2,#&f000
	LDR	r3,[r0,#canvas]
	ADD	r1,r3,#canvas_window
	STR	r2,[r1,#8]
	MOV	r2,#&f000
	STR	r2,[r1,#12]
	LDR	r2,[r3,#window_handle]
	STR	r2,[r1]
	LDR	r0,[r0,#iconhandle]
	STR	r0,[r1,#4]
	SWI	XWimp_SetIconState
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____icon_addhandler|, CODE, READONLY
	EXPORT	icon_addhandler
icon_addhandler

	ADD	r0,r0,r1,LSL#2
	LDR	r1,[r0,#mouse_handler]
	STR	r2,[r0,#mouse_handler]
	MOV	r0,r1
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____icon_setfore|, CODE, READONLY
	EXPORT	icon_setfore
icon_setfore

	LDR	r2,[r0,#canvas]
	LDR	r3,[r2,#window_handle]
	STR	r3,[r2,#canvas_window]
	LDR	r0,[r0,#iconhandle]
	STR	r0,[r2,#canvas_window+4]
	AND	r1,r1,#&f
	MOV	r1,r1,LSL#24
	STR	r1,[r2,#canvas_window+8]
	MOV	r1,#&f<<24
	STR	r1,[r2,#canvas_window+12]
	ADD	r1,r2,#canvas_window
	SWI	XWimp_SetIconState
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____icon_setback|, CODE, READONLY
	EXPORT	icon_setback
icon_setback

	LDR	r2,[r0,#canvas]
	LDR	r3,[r2,#window_handle]
	STR	r3,[r2,#canvas_window]
	LDR	r0,[r0,#iconhandle]
	STR	r0,[r2,#canvas_window+4]
	AND	r1,r1,#&f
	MOV	r1,r1,LSL#28
	STR	r1,[r2,#canvas_window+8]
	MOV	r1,#&f<<28
	STR	r1,[r2,#canvas_window+12]
	ADD	r1,r2,#canvas_window
	SWI	XWimp_SetIconState
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____icon_fill|, CODE, READONLY
	EXPORT	icon_fill
icon_fill

	LDR	r2,[r0,#canvas]
	LDR	r3,[r2,#window_handle]
	STR	r3,[r2,#canvas_window]
	LDR	r0,[r0,#iconhandle]
	STR	r0,[r2,#canvas_window+4]
	TEQ	r1,#0
	MOVEQ	r1,#0
	MOVNE	r1,#1<<5
	STR	r1,[r2,#canvas_window+8]
	MOV	r1,#1<<5
	STR	r1,[r2,#canvas_window+12]
	ADD	r1,r2,#canvas_window
	SWI	XWimp_SetIconState
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____icon_border|, CODE, READONLY
	EXPORT	icon_border
icon_border

	LDR	r2,[r0,#canvas]
	LDR	r3,[r2,#window_handle]
	STR	r3,[r2,#canvas_window]
	LDR	r0,[r0,#iconhandle]
	STR	r0,[r2,#canvas_window+4]
	TEQ	r1,#0
	MOVEQ	r1,#0
	MOVNE	r1,#1<<2
	STR	r1,[r2,#canvas_window+8]
	MOV	r1,#1<<2
	STR	r1,[r2,#canvas_window+12]
	ADD	r1,r2,#canvas_window
	SWI	XWimp_SetIconState
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____icon_update|, CODE, READONLY
	EXPORT	icon_update
icon_update

	LDR	r2,[r0,#canvas]
	LDR	r3,[r2,#window_handle]
	STR	r3,[r2,#canvas_window]
	LDR	r0,[r0,#iconhandle]
	STR	r0,[r2,#canvas_window+4]
	MOV	r1,#0
	STR	r1,[r2,#canvas_window+8]
	STR	r1,[r2,#canvas_window+12]
	ADD	r1,r2,#canvas_window
	SWI	XWimp_SetIconState
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____icon_select|, CODE, READONLY
	EXPORT	icon_select
icon_select

	LDR	r2,[r0,#canvas]
	LDR	r3,[r2,#window_handle]
	STR	r3,[r2,#canvas_window]
	LDR	r0,[r0,#iconhandle]
	STR	r0,[r2,#canvas_window+4]
	TEQ	r1,#0
	MOVEQ	r1,#0
	MOVNE	r1,#1<<21
	STR	r1,[r2,#canvas_window+8]
	MOV	r1,#1<<21
	STR	r1,[r2,#canvas_window+12]
	ADD	r1,r2,#canvas_window
	SWI	XWimp_SetIconState
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____icon_fade|, CODE, READONLY
	EXPORT	icon_fade
icon_fade

	LDR	r2,[r0,#canvas]
	LDR	r3,[r2,#window_handle]
	STR	r3,[r2,#canvas_window]
	LDR	r0,[r0,#iconhandle]
	STR	r0,[r2,#canvas_window+4]
	MOV	r12,r1
	TEQ	r1,#0
	MOVEQ	r1,#0
	MOVNE	r1,#1<<22
	STR	r1,[r2,#canvas_window+8]
	MOV	r1,#1<<22
	STR	r1,[r2,#canvas_window+12]
	ADD	r1,r2,#canvas_window
	SWI	XWimp_SetIconState
	TEQ	r12,#0
 [ arm32
	MOVEQ	pc,lr
 |
	MOVEQS	pc,lr
 ]
	MOV	r3,r1
	ADD	r1,r1,#8
	SWI	XWimp_GetCaretPosition
	LDR	r0,[r1,#0]
	LDR	r2,[r3,#0]
	TEQ	r0,r2
 [ arm32
	MOVNE	pc,lr
 |
	MOVNES	pc,lr
 ]
	LDR	r0,[r1,#4]
	LDR	r2,[r3,#4]
	TEQ	r0,r2
 [ arm32
	MOVNE	pc,lr
 |
	MOVNES	pc,lr
 ]
	STMFD	r13!,{r4,r5,lr}
	LDR	r0,[r1]
	MOV	r1,#-1
	MOV	r2,#-1
	MOV	r3,#-1
	MOV	r4,#-1
	MOV	r5,#-1
	SWI	XWimp_SetCaretPosition
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____icon_selected|, CODE, READONLY
	EXPORT	icon_selected
icon_selected

	LDR	r1,[r0,#canvas]
	LDR	r2,[r1,#window_handle]
	STR	r2,[r1,#canvas_window]!
	LDR	r3,[r0,#iconhandle]
	STR	r3,[r1,#4]
	SWI	XWimp_GetIconState
	LDR	r3,[r1,#8+16]
	TST	r3,#1<<21
	MOVEQ	r0,#0
	MOVNE	r0,#1
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____icon_faded|, CODE, READONLY
	EXPORT	icon_faded
icon_faded

	LDR	r1,[r0,#canvas]
	LDR	r2,[r1,#window_handle]
	STR	r2,[r1,#canvas_window]!
	LDR	r3,[r0,#iconhandle]
	STR	r3,[r1,#4]
	SWI	XWimp_GetIconState
	LDR	r3,[r1,#8+16]
	TST	r3,#1<<22
	MOVEQ	r0,#0
	MOVNE	r0,#1
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____icon_createradio|, CODE, READONLY
	EXPORT	icon_createradio
icon_createradio

	STMFD	r13!,{r0-r7,lr}
	MOV	r7,r0
	MOV	r0,#icon_size
	BL	rmalloc
	TEQ	r0,#0
	STREQ	r0,[r13]
 [ arm32
	LDMEQFD	r13!,{r0-r7,pc}
 |
	LDMEQFD	r13!,{r0-r7,pc}^
 ]
	STR	r0,[r13]
	MOV	r0,r7
	BL	icon_attach
	LDR	r0,[r13]
	STR	r7,[r0,#canvas]
	MOV	r2,#0
	MOV	r3,#canvas-4
icrtr_clear
	STR	r2,[r0,r3]
	SUBS	r3,r3,#4
	BPL	icrtr_clear
	ADD	r1,r7,#canvas_window
	LDR	r2,[r7,#window_handle]
	STR	r2,[r1]
	LDR	r4,[r13,#12]
	MOV	r5,#0
icrtr_count
	LDRB	r6,[r4],#1
	CMP	r6,#32
	ADDGE	r5,r5,#1
	BGE	icrtr_count
icrtr_indirect
	LDR	r0,icrtr_flags
	STR	r0,[r1,#20]
	LDR	r0,[r13,#12]
	LDR	r2,=icrtr_snames
	MOV	r3,r5
	ADD	r4,r1,#24
	STMIA	r4,{r0,r2,r3}
	LDR	r2,[r13,#4]
	STR	r2,[r1,#4]
	ADD	r2,r2,r5,LSL#4
	ADD	r2,r2,#64			; Including sprite
	STR	r2,[r1,#12]
	LDR	r2,[r13,#8]
	STR	r2,[r1,#8]
	ADD	r2,r2,#44
	STR	r2,[r1,#16]
	LDR	r0,icrtr_flags
	STR	r0,[r1,#20]
	SWI	XWimp_CreateIcon
	BVS	icon_genericfailure
	LDR	r1,[r13]
	STR	r0,[r1,#iconhandle]
	LDR	r0,[r7,#icon_list]
	STR	r0,[r1,#next_icon]
	STR	r1,[r7,#icon_list]
 [ arm32
	LDMFD	r13!,{r0-r7,pc}
 |
	LDMFD	r13!,{r0-r7,pc}^
 ]

icrtr_flags
	DCD	&17000113
	ALIGN

	AREA	iconvalids, DATA, READONLY
	EXPORT	radio_valid
radio_valid
icrtr_snames
	=	"Sradiooff,radioon",0
	ALIGN

	EXPORT	option_valid
option_valid
icrto_snames
	=	"Soptoff,opton",0
	ALIGN

	AREA	|____icon_createoption|, CODE, READONLY
	EXPORT	icon_createoption
icon_createoption

	STMFD	r13!,{r0-r7,lr}
	MOV	r7,r0
	MOV	r0,#icon_size
	BL	rmalloc
	TEQ	r0,#0
	STREQ	r0,[r13]
 [ arm32
	LDMEQFD	r13!,{r0-r7,pc}
 |
	LDMEQFD	r13!,{r0-r7,pc}^
 ]
	STR	r0,[r13]
	MOV	r0,r7
	BL	icon_attach
	LDR	r0,[r13]
	STR	r7,[r0,#canvas]
	MOV	r2,#0
	MOV	r3,#canvas-4
icrto_clear
	STR	r2,[r0,r3]
	SUBS	r3,r3,#4
	BPL	icrto_clear
	ADD	r1,r7,#canvas_window
	LDR	r2,[r7,#window_handle]
	STR	r2,[r1]
	LDR	r4,[r13,#12]
	MOV	r5,#0
icrto_count
	LDRB	r6,[r4],#1
	CMP	r6,#32
	ADDGE	r5,r5,#1
	BGE	icrto_count
icrto_indirect
	LDR	r0,icrto_flags
	STR	r0,[r1,#20]
	LDR	r0,[r13,#12]
	LDR	r2,=icrto_snames
	MOV	r3,r5
	ADD	r4,r1,#24
	STMIA	r4,{r0,r2,r3}
	LDR	r2,[r13,#4]
	STR	r2,[r1,#4]
	ADD	r2,r2,r5,LSL#4
	ADD	r2,r2,#64			; Including sprite
	STR	r2,[r1,#12]
	LDR	r2,[r13,#8]
	STR	r2,[r1,#8]
	ADD	r2,r2,#44
	STR	r2,[r1,#16]
	LDR	r0,icrto_flags
	STR	r0,[r1,#20]
	SWI	XWimp_CreateIcon
	BVS	icon_genericfailure
	LDR	r1,[r13]
	STR	r0,[r1,#iconhandle]
	LDR	r0,[r7,#icon_list]
	STR	r0,[r1,#next_icon]
	STR	r1,[r7,#icon_list]
 [ arm32
	LDMFD	r13!,{r0-r7,pc}
 |
	LDMFD	r13!,{r0-r7,pc}^
 ]

icrto_flags
	DCD	&17000113
	AREA	|____icon_handle|, CODE, READONLY
	EXPORT	icon_handle
icon_handle

	LDR	r0,[r0,#iconhandle]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____icon_canvas|, CODE, READONLY
	EXPORT	icon_canvas
icon_canvas

	LDR	r0,[r0,#canvas]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____icon_remove|, CODE, READONLY
	EXPORT	icon_remove
icon_remove

	LDR	r1,[r0,#canvas]
	LDR	r3,[r0,#next_icon]
	ADD	r2,r1,#icon_list
rmve_findicon
	LDR	r1,[r2]
	TEQ	r1,r0
	STREQ	r3,[r2]
	MOVEQ	r1,#0
	MOVS	r2,r1
	BNE	rmve_findicon
	LDR	r1,[r0,#canvas]
	LDR	r2,[r1,#window_handle]
	STR	r2,[r1,#canvas_window]!
	LDR	r2,[r0,#iconhandle]
	STR	r2,[r1,#4]
	SWI	XWimp_DeleteIcon
 [ arm32
	MOVVS	pc,lr
 |
	MOVVSS	pc,lr
 ]
	B	rfree						; And close the icon space

	AREA	|____icon_useexisting|, CODE, READONLY
	EXPORT	icon_useexisting
icon_useexisting

	STMFD	r13!,{r0,r4,r5,lr}
	MOV	r4,r0
	MOV	r5,r1
	MOV	r0,#icon_size
	BL	rmalloc
	TEQ	r0,#0
	STREQ	r0,[r13]
 [ arm32
	LDMEQFD	r13!,{r0,r4,r5,pc}
 |
	LDMEQFD	r13!,{r0,r4,r5,pc}^
 ]
	STR	r4,[r0,#canvas]
	MOV	r2,#0
	MOV	r3,#canvas-4
iusex_clear
	STR	r2,[r0,r3]
	SUBS	r3,r3,#4
	BPL	iusex_clear
	LDR	r1,[r4,#icon_list]
	STR	r0,[r4,#icon_list]
	STR	r1,[r0,#next_icon]
	STR	r5,[r0,#iconhandle]
	STR	r0,[r13]
	MOV	r0,r4
	BL	icon_attach
 [ arm32
	LDMFD	r13!,{r0,r4,r5,pc}
 |
	LDMFD	r13!,{r0,r4,r5,pc}^
 ]

	AREA	|____icon_textpointer|, CODE, READONLY
	EXPORT	icon_textpointer
icon_textpointer

; r0 is icon
; returns r0 as ^ text
	LDR	r1,[r0,#canvas]
	LDR	r3,[r1,#window_handle]
	STR	r3,[r1,#canvas_window]!
	LDR	r3,[r0,#iconhandle]
	STR	r3,[r1,#4]
	SWI	XWimp_GetIconState
	LDR	r0,[r1,#8+20]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____icon_validpointer|, CODE, READONLY
	EXPORT	icon_validpointer
icon_validpointer

; r0 is icon
; returns r0 as ^ text
	LDR	r1,[r0,#canvas]
	LDR	r3,[r1,#window_handle]
	STR	r3,[r1,#canvas_window]!
	LDR	r3,[r0,#iconhandle]
	STR	r3,[r1,#4]
	SWI	XWimp_GetIconState
	LDR	r0,[r1,#8+24]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____icon_setgroup|, CODE, READONLY
	EXPORT	icon_setgroup
icon_setgroup

	AND	r2,r1,#&1f
	LDR	r1,[r0,#canvas]
	LDR	r3,[r1,#window_handle]
	STR	r3,[r1,#canvas_window]!
	MOV	r2,r2,LSL#16
	STR	r2,[r1,#8]
	LDR	r3,[r0,#iconhandle]
	STR	r3,[r1,#4]
	MOV	r2,#&1f<<16
	STR	r2,[r1,#12]
	SWI	XWimp_SetIconState
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____icon_setcaret|, CODE, READONLY
	EXPORT	icon_setcaret
icon_setcaret

; r0 is icon
; r1 is screen_x
; r2 is screen_y
; r3 is offset into string

	STMFD	r13!,{r4,r5,lr}
	MOV	r5,r3
	MOV	r4,#-1
	MOV	r3,r2
	MOV	r2,r1
	LDR	r1,[r0,#iconhandle]
	LDR	r0,[r0,#canvas]
	LDR	r0,[r0,#window_handle]
	SWI	XWimp_SetCaretPosition;
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	AREA	|____icon_createinfofield|, CODE, READONLY
	EXPORT	icon_createinfofield
icon_createinfofield

; r0 is canvas
; r1 is lx
; r2 is by
; r3 is ^ string

	STMFD	r13!,{r0-r7,lr}
	MOV	r7,r0
	MOV	r0,#icon_size
	BL	rmalloc
	TEQ	r0,#0
	STREQ	r0,[r13]
 [ arm32
	LDMEQFD	r13!,{r0-r7,pc}
 |
	LDMEQFD	r13!,{r0-r7,pc}^
 ]
	STR	r0,[r13]
	MOV	r0,r7
	BL	icon_attach
	LDR	r0,[r13]
	STR	r7,[r0,#canvas]
	MOV	r2,#0
	MOV	r3,#canvas-4
icrtif_clear
	STR	r2,[r0,r3]
	SUBS	r3,r3,#4
	BPL	icrtif_clear
	ADD	r1,r7,#canvas_window
	LDR	r2,[r7,#window_handle]
	STR	r2,[r1]
	LDR	r4,[r13,#12]
	STMFD	r13!,{r0,r1,r3}
	MOV	r0,r4
	BL	main_strwidth
	ADD	r5,r0,#16
	LDMFD	r13!,{r0,r1,r3}
	LDR	r2,[r13,#4]
	STR	r2,[r1,#4]
	ADD	r2,r2,r5
	STR	r2,[r1,#12]
	LDR	r2,[r13,#8]
	STR	r2,[r1,#8]
	ADD	r2,r2,#52
	STR	r2,[r1,#16]
	BL	get_3dstatus
	TEQ	r0,#0
	ADD	r1,r7,#canvas_window
	LDR	r2,[r7,#window_handle]
	STR	r2,[r1]
	LDR	r4,[r13,#12]
	LDRNE	r0,icrtif_3dflags
	LDREQ	r0,icrtif_2dflags
	STR	r0,[r1,#20]
	LDR	r0,[r13,#12]
	ADRNE	r2,icrtif_3dvalid
	MOVEQ	r2,#-1
	MOV	r3,#12
	ADD	r4,r1,#24
	STMIA	r4,{r0,r2,r3}
icrtif_make
	SWI	XWimp_CreateIcon
	BVS	icon_genericfailure
	LDR	r1,[r13]
	STR	r0,[r1,#iconhandle]
	LDR	r0,[r7,#icon_list]
	STR	r0,[r1,#next_icon]
	STR	r1,[r7,#icon_list]
 [ arm32
	LDMFD	r13!,{r0-r7,pc}
 |
	LDMFD	r13!,{r0-r7,pc}^
 ]

icrtif_3dflags
	DCD	&1700013d
icrtif_3dvalid
	=	"r2",0
	ALIGN
icrtif_2dflags
	DCD	&0700013d

	AREA	|____icon_createfixedinfofield|, CODE, READONLY
	EXPORT	icon_createfixedinfofield
icon_createfixedinfofield

; r0 is canvas
; r1 is lx
; r2 is by
; r3 is ^ string
; !r13 is width

	LDR	r12,[r13]
	STMFD	r13!,{r0-r7,lr}
	MOV	r6,r12
	MOV	r7,r0
	MOV	r0,#icon_size
	BL	rmalloc
	TEQ	r0,#0
	STREQ	r0,[r13]
 [ arm32
	LDMEQFD	r13!,{r0-r7,pc}
 |
	LDMEQFD	r13!,{r0-r7,pc}^
 ]
	STR	r0,[r13]
	MOV	r0,r7
	BL	icon_attach
	LDR	r0,[r13]
	STR	r7,[r0,#canvas]
	MOV	r2,#0
	MOV	r3,#canvas-4
icrtfif_clear
	STR	r2,[r0,r3]
	SUBS	r3,r3,#4
	BPL	icrtfif_clear
	ADD	r1,r7,#canvas_window
	LDR	r2,[r7,#window_handle]
	STR	r2,[r1]
	LDR	r4,[r13,#12]
	LDR	r2,[r13,#4]
	STR	r2,[r1,#4]
	ADD	r2,r2,r6
	STR	r2,[r1,#12]
	LDR	r2,[r13,#8]
	STR	r2,[r1,#8]
	ADD	r2,r2,#52
	STR	r2,[r1,#16]
	BL	get_3dstatus
	TEQ	r0,#0
	ADD	r1,r7,#canvas_window
	LDR	r2,[r7,#window_handle]
	STR	r2,[r1]
	LDR	r4,[r13,#12]
	LDRNE	r0,icrtfif_3dflags
	LDREQ	r0,icrtfif_2dflags
	STR	r0,[r1,#20]
	LDR	r0,[r13,#12]
	ADRNE	r2,icrtfif_3dvalid
	MOVEQ	r2,#-1
	MOV	r3,#12
	ADD	r4,r1,#24
	STMIA	r4,{r0,r2,r3}
icrtfif_make
	SWI	XWimp_CreateIcon
	BVS	icon_genericfailure
	LDR	r1,[r13]
	STR	r0,[r1,#iconhandle]
	LDR	r0,[r7,#icon_list]
	STR	r0,[r1,#next_icon]
	STR	r1,[r7,#icon_list]
 [ arm32
	LDMFD	r13!,{r0-r7,pc}
 |
	LDMFD	r13!,{r0-r7,pc}^
 ]

icrtfif_3dflags
	DCD	&1700013d
icrtfif_3dvalid
	=	"r2",0
	ALIGN
icrtfif_2dflags
	DCD	&0700013d

	AREA	|____icon_createmenubutton|, CODE, READONLY
	EXPORT	icon_createmenubutton
icon_createmenubutton

	STMFD	r13!,{r0-r6,lr}
	BL	get_3dstatus
	TEQ	r0,#0
	LDMFD	r13!,{r0-r3}
	SUB	r13,r13,#12
	ADDNE	r2,r2,#4
	ADDNE	r4,r2,#44
	ADDNE	r3,r1,#44
	ADDEQ	r4,r2,#52
	ADDEQ	r3,r1,#52
	LDRNE	r5,icrtmb_flags
	ADRNE	r6,icrtmb_data
	LDREQ	r5,icrtmb_2dflags
	ADREQ	r6,icrtmb_2ddata
	STMIA	r13,{r4-r6}
	BL	icon_create
	ADD	r13,r13,#12
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]

icrtmb_flags
	DCD	&1700311b
icrtmb_data
	DCD	icrtmb_nulltext
	DCD	icrtmb_valid
	DCD	12
icrtmb_nulltext
	=	0
icrtmb_valid
	=	"r5;sgright,pgright;pptr_menu,2,2",0
	ALIGN
icrtmb_2dflags
	DCD	&3700303d
icrtmb_2ddata
	=	137,0
	ALIGN

	AREA	|____icon_createsprite|, CODE, READONLY
	EXPORT	icon_createsprite
icon_createsprite

	LDR	r12,[r13]
	STMFD	r13!,{r0-r7,lr}
	MOV	r6,r12
	MOV	r7,r0
	MOV	r0,#icon_size
	BL	rmalloc
	STR	r0,[r13]
	TEQ	r0,#0
 [ arm32
	LDMEQFD	r13!,{r0-r7,pc}
 |
	LDMEQFD	r13!,{r0-r7,pc}^
 ]
	MOV	r0,r7
	BL	icon_attach
	LDR	r0,[r13]
	STR	r7,[r0,#canvas]
	ADD	r1,r7,#canvas_window
	LDR	r0,[r7,#window_handle]
	STR	r0,[r1]
	STR	r6,[r1,#4+20]
	STR	r6,[r1,#4+28]
	LDR	r0,[r13,#12]
	STR	r0,[r1,#4+24]
	STMFD	r13!,{r1}
	MOV	r1,r6
	BL	icon_getspritedimensions
	MOV	r4,r1
	MOV	r3,r0
	LDMFD	r13!,{r1}
	LDMIB	r13,{r0,r2}
	ADD	r3,r3,r0
	ADD	r4,r4,r2
	LDR	r5,icrts_flags
	ADD	r1,r7,#canvas_window
	STMIB	r1,{r0,r2-r5}
	SWI	XWimp_CreateIcon
	BVS	icon_genericfailure
	LDR	r1,[r13]
	STR	r0,[r1,#iconhandle]
	LDR	r0,[r7,#icon_list]
	STR	r0,[r1,#next_icon]
	STR	r1,[r7,#icon_list]
 [ arm32
	LDMFD	r13!,{r0-r7,pc}
 |
	LDMFD	r13!,{r0-r7,pc}^
 ]

icrts_flags
	DCD	&1700011a

	AREA	icon_getspritedimensions, CODE, READONLY

; r0 is ^ sprite area
; r1 is ^ sprite name

	STMFD	r13!,{r2-r6,lr}
	MOV	r2,r1
	MOV	r1,r0
	MOV	r0,#40
	TEQ	r1,#1
	ORRNE	r0,r0,#256
	SWIEQ	XWimp_SpriteOp
	SWINE	XOS_SpriteOp
	MOVVS	r0,#0
	MOVVS	r1,#0
 [ arm32
	LDMVSFD	r13!,{r2-r6,pc}
 |
	LDMVSFD	r13!,{r2-r6,pc}^
 ]
	MOV	r0,r6
	MOV	r1,#4
	SWI	XOS_ReadModeVariable
	MOV	r3,r3,LSL r2
	MOV	r1,#5
	SWI	XOS_ReadModeVariable
	MOV	r1,r4,LSL r2
	MOV	r0,r3
 [ arm32
	LDMFD	r13!,{r2-r6,pc}
 |
	LDMFD	r13!,{r2-r6,pc}^
 ]

 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____icon_createdefaultbutton|, CODE, READONLY
	EXPORT	icon_createdefaultbutton
icon_createdefaultbutton

; r0 is canvas
; r1 is lx
; r2 is by
; r3 is ^ string
; !r13 is width

	LDR	r12,[r13]
	STMFD	r13!,{r0-r7,lr}
	MOV	r6,r12
	MOV	r7,r0
	MOV	r0,#icon_size
	BL	rmalloc
	TEQ	r0,#0
	STREQ	r0,[r13]
 [ arm32
	LDMEQFD	r13!,{r0-r7,pc}
 |
	LDMEQFD	r13!,{r0-r7,pc}^
 ]
	STR	r0,[r13]
	MOV	r0,r7
	BL	icon_attach
	LDR	r0,[r13]
	STR	r7,[r0,#canvas]
	MOV	r2,#0
	MOV	r3,#canvas-4
icrtdb_clear
	STR	r2,[r0,r3]
	SUBS	r3,r3,#4
	BPL	icrtdb_clear
	ADD	r1,r7,#canvas_window
	LDR	r2,[r7,#window_handle]
	STR	r2,[r1]
	STMFD	r13!,{r1-r3}
	BL	get_3dstatus
	TEQ	r0,#0
	LDMFD	r13!,{r1-r3}
	LDR	r4,[r13,#12]
	LDR	r2,[r13,#4]
	SUBNE	r2,r2,#8
	STR	r2,[r1,#4]
	ADDNE	r2,r2,#16
	ADD	r2,r2,r6
	STR	r2,[r1,#12]
	LDR	r2,[r13,#8]
	SUBNE	r2,r2,#8
	STR	r2,[r1,#8]
	ADDNE	r2,r2,#68
	ADDEQ	r2,r2,#52
	STR	r2,[r1,#16]
	ADD	r1,r7,#canvas_window
	LDR	r2,[r7,#window_handle]
	STR	r2,[r1]
	LDR	r4,[r13,#12]
	LDRNE	r0,icrtdb_3dflags
	LDREQ	r0,icrtdb_2dflags
	STR	r0,[r1,#20]
	LDR	r0,[r13,#12]
	ADRNE	r2,icrtdb_3dvalid
	MOVEQ	r2,#-1
	MOV	r3,#12
	ADD	r4,r1,#24
	STMIA	r4,{r0,r2,r3}
icrtdb_make
	SWI	XWimp_CreateIcon
	BVS	icon_genericfailure
	LDR	r1,[r13]
	STR	r0,[r1,#iconhandle]
	LDR	r0,[r7,#icon_list]
	STR	r0,[r1,#next_icon]
	STR	r1,[r7,#icon_list]
 [ arm32
	LDMFD	r13!,{r0-r7,pc}
 |
	LDMFD	r13!,{r0-r7,pc}^
 ]

icrtdb_3dflags
	DCD	&1700313d
icrtdb_3dvalid
	=	"r6,3",0
	ALIGN
icrtdb_2dflags
	DCD	&c70f913d

	AREA	|____icon_createbutton|, CODE, READONLY
	EXPORT	icon_createbutton
icon_createbutton

; r0 is canvas
; r1 is lx
; r2 is by
; r3 is ^ string
; !r13 is width

	LDR	r12,[r13]
	STMFD	r13!,{r0-r7,lr}
	MOV	r6,r12
	MOV	r7,r0
	MOV	r0,#icon_size
	BL	rmalloc
	TEQ	r0,#0
	STREQ	r0,[r13]
 [ arm32
	LDMEQFD	r13!,{r0-r7,pc}
 |
	LDMEQFD	r13!,{r0-r7,pc}^
 ]
	STR	r0,[r13]
	MOV	r0,r7
	BL	icon_attach
	LDR	r0,[r13]
	STR	r7,[r0,#canvas]
	MOV	r2,#0
	MOV	r3,#canvas-4
icrtbtn_clear
	STR	r2,[r0,r3]
	SUBS	r3,r3,#4
	BPL	icrtbtn_clear
	ADD	r1,r7,#canvas_window
	LDR	r2,[r7,#window_handle]
	STR	r2,[r1]
	LDR	r4,[r13,#12]
	LDR	r2,[r13,#4]
	STR	r2,[r1,#4]
	ADD	r2,r2,r6
	STR	r2,[r1,#12]
	LDR	r2,[r13,#8]
	STR	r2,[r1,#8]
	ADD	r2,r2,#52
	STR	r2,[r1,#16]
	BL	get_3dstatus
	TEQ	r0,#0
	ADD	r1,r7,#canvas_window
	LDR	r2,[r7,#window_handle]
	STR	r2,[r1]
	LDR	r4,[r13,#12]
	LDRNE	r0,icrtbtn_3dflags
	LDREQ	r0,icrtbtn_2dflags
	STR	r0,[r1,#20]
	LDR	r0,[r13,#12]
	ADRNE	r2,icrtbtn_3dvalid
	MOVEQ	r2,#-1
	MOV	r3,#12
	ADD	r4,r1,#24
	STMIA	r4,{r0,r2,r3}
icrtbtn_make
	SWI	XWimp_CreateIcon
	BVS	icon_genericfailure
	LDR	r1,[r13]
	STR	r0,[r1,#iconhandle]
	LDR	r0,[r7,#icon_list]
	STR	r0,[r1,#next_icon]
	STR	r1,[r7,#icon_list]
 [ arm32
	LDMFD	r13!,{r0-r7,pc}
 |
	LDMFD	r13!,{r0-r7,pc}^
 ]

icrtbtn_3dflags
	DCD	&1700313d
icrtbtn_3dvalid
	=	"r5,3",0
	ALIGN
icrtbtn_2dflags
	DCD	&070f913d

	AREA	|____icon_createwriteable|, CODE, READONLY
	EXPORT	icon_createwriteable
icon_createwriteable

; r0 is canvas
; r1 is lx
; r2 is by
; r3 is ^ string
; !r13 is ^ valid
; r13!4 is #characters
; r13!8 is width

	MOV	r12,r13
	STMFD	r13!,{r0-r7,lr}
	MOV	r5,r12
	LDR	r6,[r12,#8]
	MOV	r7,r0
	MOV	r0,#icon_size
	BL	rmalloc
	MOV	r12,r5
	TEQ	r0,#0
	STREQ	r0,[r13]
 [ arm32
	LDMEQFD	r13!,{r0-r7,pc}
 |
	LDMEQFD	r13!,{r0-r7,pc}^
 ]
	STR	r0,[r13]
	MOV	r0,r7
	BL	icon_attach
	LDR	r0,[r13]
	STR	r7,[r0,#canvas]
	MOV	r2,#0
	MOV	r3,#canvas-4
icrtwf_clear
	STR	r2,[r0,r3]
	SUBS	r3,r3,#4
	BPL	icrtwf_clear
	ADD	r1,r7,#canvas_window
	LDR	r2,[r7,#window_handle]
	STR	r2,[r1]
	LDR	r4,[r13,#12]
	LDR	r2,[r13,#4]
	STR	r2,[r1,#4]
	ADD	r2,r2,r6
	STR	r2,[r1,#12]
	LDR	r2,[r13,#8]
	STR	r2,[r1,#8]
	ADD	r2,r2,#52
	STR	r2,[r1,#16]
	ADD	r1,r7,#canvas_window
	LDR	r2,[r7,#window_handle]
	STR	r2,[r1]
	LDR	r4,[r13,#12]
	LDR	r0,icrtwf_flags
	STR	r0,[r1,#20]
	LDR	r0,[r13,#12]
	LDMIA	r12,{r2,r3}
	ADD	r4,r1,#24
	STMIA	r4,{r0,r2,r3}
icrtwf_make
	SWI	XWimp_CreateIcon
	BVS	icon_genericfailure
	LDR	r1,[r13]
	STR	r0,[r1,#iconhandle]
	LDR	r0,[r7,#icon_list]
	STR	r0,[r1,#next_icon]
	STR	r1,[r7,#icon_list]
 [ arm32
	LDMFD	r13!,{r0-r7,pc}
 |
	LDMFD	r13!,{r0-r7,pc}^
 ]

icrtwf_flags
	DCD	&0700f13d

	AREA	|____icon_createrjtext|, CODE, READONLY
	EXPORT	icon_createrjtext
icon_createrjtext

	STMFD	r13!,{r0-r7,lr}
	MOV	r7,r0
	MOV	r0,#icon_size
	BL	rmalloc
	TEQ	r0,#0
	STREQ	r0,[r13]
 [ arm32
	LDMEQFD	r13!,{r0-r7,pc}
 |
	LDMEQFD	r13!,{r0-r7,pc}^
 ]
	STR	r0,[r13]
	MOV	r0,r7
	BL	icon_attach
	LDR	r0,[r13]
	STR	r7,[r0,#canvas]
	MOV	r2,#0
	MOV	r3,#canvas-4
icrtrjt_clear
	STR	r2,[r0,r3]
	SUBS	r3,r3,#4
	BPL	icrtrjt_clear
	ADD	r1,r7,#canvas_window
	LDR	r2,[r7,#window_handle]
	STR	r2,[r1]
	LDR	r4,[r13,#12]
	ADD	lr,r1,#24
	MOV	r5,#0
icrtrjt_count
	LDRB	r6,[r4,r5]
	CMP	r5,#12
	STRLEB	r6,[lr,r5]
	CMP	r6,#32
	ADDGE	r5,r5,#1
	BGE	icrtrjt_count
	STMFD	r13!,{r0-r3,lr}
	MOV	r0,r4
	BL	main_strwidth
	ADD	r4,r0,#16
	LDMFD	r13!,{r0-r3,lr}
	LDR	r2,[r13,#4]
	SUB	r4,r2,r4
	STR	r4,[r1,#4]
;	ADD	r2,r2,r4
	STR	r2,[r1,#12]
	LDR	r2,[r13,#8]
	STR	r2,[r1,#8]
	ADD	r2,r2,#52
	STR	r2,[r1,#16]
	CMP	r5,#12
	BGT	icrtrjt_indirect
	LDR	r0,icrtrjt_flags
	STR	r0,[r1,#20]
icrtrjt_make
	SWI	XWimp_CreateIcon
	BVS	icon_genericfailure
	LDR	r1,[r13]
	STR	r0,[r1,#iconhandle]
	LDR	r0,[r7,#icon_list]
	STR	r0,[r1,#next_icon]
	STR	r1,[r7,#icon_list]
 [ arm32
	LDMFD	r13!,{r0-r7,pc}
 |
	LDMFD	r13!,{r0-r7,pc}^
 ]
icrtrjt_indirect
	LDR	r0,icrtrjt_flags
	ORR	r0,r0,#256
	STR	r0,[r1,#20]
	LDR	r0,[r13,#12]
	MOV	r2,#-1
	MOV	r3,r6
	ADD	r4,r1,#24
	STMIA	r4,{r0,r2,r3}
	B	icrtrjt_make

icrtrjt_flags
	DCD	&17000201

	AREA	icon_genericfailure, CODE, READONLY

	LDR	r0,[r13]
	BL	rfree
	MOV	r0,#0
	STR	r0,[r13]
 [ arm32
	LDMFD	r13!,{r0-r7,pc}
 |
	LDMFD	r13!,{r0-r7,pc}^
 ]

	AREA	|____icon_createbox|, CODE
	EXPORT	icon_createbox
icon_createbox

	MOV	r12,r13
	STMFD	r13!,{r4-r9,lr}
	LDR	r0,[r0,#window_handle]
	ADR	r9,icon_winboxhand
	LDR	r4,[r12]
	STMIA	r9!,{r0-r4}
	BL	get_3dstatus
	TEQ	r0,#0
	LDREQ	r0,icon_2Dboxflags
	LDRNE	r0,icon_3Dboxflags
	ADRNE	r2,icon_3Dboxvalid
	MOVEQ	r2,#-1
	ADR	r1,icon_nullboxstring
	MOV	r3,#1
	STMIA	r9!,{r0-r3}
	ADR	r1,icon_winboxhand
	SWI	XWimp_CreateIcon
	ADD	r1,r1,#4
	LDR	r0,icon_textboxflags
	STR	r0,[r1,#16]
	LDMIA	r1,{r4-r7}
	ADD	r4,r4,#12
	SUB	r5,r7,#20
	ADD	r7,r5,#32
	LDR	r0,[r12,#4]
	BL	main_strwidth
	ADD	r0,r0,#16
	ADD	r6,r4,r0
	ADR	r1,icon_winboxhand
	STMIB	r1,{r4-r7}
	LDR	r0,[r12,#4]
	STR	r0,[r1,#24]
	MOV	r0,#-1
	STR	r0,[r1,#28]
	SWI	XWimp_CreateIcon
 [ arm32
	LDMFD	r13!,{r4-r9,pc}
 |
	LDMFD	r13!,{r4-r9,pc}^
 ]

icon_3Dboxflags
	DCD	&17000105
icon_2Dboxflags
	DCD	&17000004
icon_3Dboxvalid
	=	"r4"
icon_nullboxstring
	=	0
	ALIGN
icon_textboxflags
	DCD	&17000139

icon_winboxhand
	%	4
icon_createboxdata
	%	32

	AREA	|____icon_setjustification|, CODE, READONLY
	EXPORT	icon_setjustification
icon_setjustification

	AND	r2,r1,#&208
	LDR	r3,[r0,#canvas]
	ADD	r1,r3,#canvas_window
	STR	r2,[r1,#8]
	MOV	r2,#&208
	STR	r2,[r1,#12]
	LDR	r2,[r3,#window_handle]
	STR	r2,[r1]
	LDR	r0,[r0,#iconhandle]
	STR	r0,[r1,#4]
	SWI	XWimp_SetIconState
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____icon_setfont|, CODE, READONLY
	EXPORT	icon_setfont
icon_setfont

	MOVS	r2,r1
	MOVPL	r2,r2,LSL#24
	ORRPL	r2,r2,#1<<6
	MOVMI	r2,#7<<24
	LDR	r3,[r0,#canvas]
	ADD	r1,r3,#canvas_window
	STR	r2,[r1,#8]
	MOV	r2,#&ff<<24
	ORR	r2,r2,#1<<6
	STR	r2,[r1,#12]
	LDR	r2,[r3,#window_handle]
	STR	r2,[r1]
	LDR	r0,[r0,#iconhandle]
	STR	r0,[r1,#4]
	SWI	XWimp_SetIconState
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	END
