; template.s

	GET	swis.s
	GET	registers.s

	AREA	|____template_open|, CODE, READONLY
	EXPORT	template_open
template_open

	MOV	r1,r0
	SWI	XWimp_OpenTemplate
	MOVVS	r0,#0
	MOVVC	r0,#1
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____template_close|, CODE, READONLY
	EXPORT	template_close
template_close

	SWI	XWimp_CloseTemplate
	MOVVS	r0,#0
	MOVVC	r0,#1
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____template_setworkspace|, CODE, READONLY
	EXPORT	template_setworkspace
template_setworkspace

; r0 is ^ temporary workspace

	LDR	r2,=Addr
	STR	r0,[r2]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	template_workspace, DATA

Addr	%	4

	AREA	template_data, COMMON, NOINIT
	%	4

	AREA	template_name, COMMON, NOINIT
	%	12

	AREA	template_spritepool, DATA
	DCD	1

	AREA	|____template_setspritearea|, CODE, READONLY
	EXPORT	template_setspritearea
template_setspritearea

	LDR	r1,=template_spritepool
	LDR	r2,[r1]
	STR	r0,[r1]
	MOV	r0,r2
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____template_canvas|, CODE, READONLY
	EXPORT	template_canvas
template_canvas

; r0 is ^ template name
; r1 is ^ indirected data block
; r2 is ^ end of data block
; returns r0 as ^ canvas, 0 if not found/not allocatable
	STMFD	r13!,{r4-r6,lr}
	LDMIA	r0,{r4-r6}
	LDR	r3,=template_name
	STMIA	r3,{r4-r6}
	MOV	r6,#0
	MOV	r5,r3
	MOV	r4,#-1
	MOV	r3,r2
	MOV	r2,r1
	LDR	r1,=Addr
	LDR	r1,[r1]
	SWI	XWimp_LoadTemplate
	TEQ	r6,#0
	MOVEQ	r0,#0
 [ arm32
	LDMEQFD	r13!,{r4-r6,pc}
 |
	LDMEQFD	r13!,{r4-r6,pc}^
 ]
	LDR	r0,=template_spritepool
	LDR	r3,[r0]
	STR	r3,[r1,#64]
	LDR	r0,=template_data
	STR	r2,[r0]
	SWI	XWimp_CreateWindow
	MOVVS	r0,#0
 [ arm32
	LDMVSFD	r13!,{r4-r6,pc}
 |
	LDMVSFD	r13!,{r4-r6,pc}^
 ]
	LDMFD	r13!,{r4-r6,lr}

	IMPORT	canvas_addtolist
	B	canvas_addtolist

	END
